Merge branch 'maint-1.7.11' into maint
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # Test the binaries we have just built.  The tests are kept in
38 # t/ subdirectory and are run in 'trash directory' subdirectory.
39 if test -z "$TEST_DIRECTORY"
40 then
41         # We allow tests to override this, in case they want to run tests
42         # outside of t/, e.g. for running tests on the test library
43         # itself.
44         TEST_DIRECTORY=$(pwd)
45 fi
46 if test -z "$TEST_OUTPUT_DIRECTORY"
47 then
48         # Similarly, override this to store the test-results subdir
49         # elsewhere
50         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
51 fi
52 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
53
54 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
55 export PERL_PATH SHELL_PATH
56
57 # For repeatability, reset the environment to known value.
58 LANG=C
59 LC_ALL=C
60 PAGER=cat
61 TZ=UTC
62 TERM=dumb
63 export LANG LC_ALL PAGER TERM TZ
64 EDITOR=:
65 # A call to "unset" with no arguments causes at least Solaris 10
66 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
67 # deriving from the command substitution clustered with the other
68 # ones.
69 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
70         my @env = keys %ENV;
71         my $ok = join("|", qw(
72                 TRACE
73                 DEBUG
74                 USE_LOOKUP
75                 TEST
76                 .*_TEST
77                 PROVE
78                 VALGRIND
79                 PERF_AGGREGATING_LATER
80         ));
81         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
82         print join("\n", @vars);
83 ')
84 unset XDG_CONFIG_HOME
85 GIT_AUTHOR_EMAIL=author@example.com
86 GIT_AUTHOR_NAME='A U Thor'
87 GIT_COMMITTER_EMAIL=committer@example.com
88 GIT_COMMITTER_NAME='C O Mitter'
89 GIT_MERGE_VERBOSITY=5
90 GIT_MERGE_AUTOEDIT=no
91 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
92 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
93 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
94 export EDITOR
95
96 # Protect ourselves from common misconfiguration to export
97 # CDPATH into the environment
98 unset CDPATH
99
100 unset GREP_OPTIONS
101
102 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
103         1|2|true)
104                 echo "* warning: Some tests will not work if GIT_TRACE" \
105                         "is set as to trace on STDERR ! *"
106                 echo "* warning: Please set GIT_TRACE to something" \
107                         "other than 1, 2 or true ! *"
108                 ;;
109 esac
110
111 # Convenience
112 #
113 # A regexp to match 5 and 40 hexdigits
114 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
115 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
116
117 # Zero SHA-1
118 _z40=0000000000000000000000000000000000000000
119
120 # Line feed
121 LF='
122 '
123
124 export _x05 _x40 _z40 LF
125
126 # Each test should start with something like this, after copyright notices:
127 #
128 # test_description='Description of this test...
129 # This test checks if command xyzzy does the right thing...
130 # '
131 # . ./test-lib.sh
132 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
133                 TERM=$ORIGINAL_TERM &&
134                 export TERM &&
135                 [ -t 1 ] &&
136                 tput bold >/dev/null 2>&1 &&
137                 tput setaf 1 >/dev/null 2>&1 &&
138                 tput sgr0 >/dev/null 2>&1
139         ) &&
140         color=t
141
142 while test "$#" -ne 0
143 do
144         case "$1" in
145         -d|--d|--de|--deb|--debu|--debug)
146                 debug=t; shift ;;
147         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
148                 immediate=t; shift ;;
149         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
150                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
151         -h|--h|--he|--hel|--help)
152                 help=t; shift ;;
153         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
154                 verbose=t; shift ;;
155         -q|--q|--qu|--qui|--quie|--quiet)
156                 # Ignore --quiet under a TAP::Harness. Saying how many tests
157                 # passed without the ok/not ok details is always an error.
158                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
159         --with-dashes)
160                 with_dashes=t; shift ;;
161         --no-color)
162                 color=; shift ;;
163         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
164                 valgrind=t; verbose=t; shift ;;
165         --tee)
166                 shift ;; # was handled already
167         --root=*)
168                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
169                 shift ;;
170         *)
171                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
172         esac
173 done
174
175 if test -n "$color"; then
176         say_color () {
177                 (
178                 TERM=$ORIGINAL_TERM
179                 export TERM
180                 case "$1" in
181                         error) tput bold; tput setaf 1;; # bold red
182                         skip)  tput bold; tput setaf 2;; # bold green
183                         pass)  tput setaf 2;;            # green
184                         info)  tput setaf 3;;            # brown
185                         *) test -n "$quiet" && return;;
186                 esac
187                 shift
188                 printf "%s" "$*"
189                 tput sgr0
190                 echo
191                 )
192         }
193 else
194         say_color() {
195                 test -z "$1" && test -n "$quiet" && return
196                 shift
197                 echo "$*"
198         }
199 fi
200
201 error () {
202         say_color error "error: $*"
203         GIT_EXIT_OK=t
204         exit 1
205 }
206
207 say () {
208         say_color info "$*"
209 }
210
211 test "${test_description}" != "" ||
212 error "Test script did not set test_description."
213
214 if test "$help" = "t"
215 then
216         echo "$test_description"
217         exit 0
218 fi
219
220 exec 5>&1
221 exec 6<&0
222 if test "$verbose" = "t"
223 then
224         exec 4>&2 3>&1
225 else
226         exec 4>/dev/null 3>/dev/null
227 fi
228
229 test_failure=0
230 test_count=0
231 test_fixed=0
232 test_broken=0
233 test_success=0
234
235 test_external_has_tap=0
236
237 die () {
238         code=$?
239         if test -n "$GIT_EXIT_OK"
240         then
241                 exit $code
242         else
243                 echo >&5 "FATAL: Unexpected exit with code $code"
244                 exit 1
245         fi
246 }
247
248 GIT_EXIT_OK=
249 trap 'die' EXIT
250
251 # The user-facing functions are loaded from a separate file so that
252 # test_perf subshells can have them too
253 . "$TEST_DIRECTORY/test-lib-functions.sh"
254
255 # You are not expected to call test_ok_ and test_failure_ directly, use
256 # the text_expect_* functions instead.
257
258 test_ok_ () {
259         test_success=$(($test_success + 1))
260         say_color "" "ok $test_count - $@"
261 }
262
263 test_failure_ () {
264         test_failure=$(($test_failure + 1))
265         say_color error "not ok - $test_count $1"
266         shift
267         echo "$@" | sed -e 's/^/#       /'
268         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
269 }
270
271 test_known_broken_ok_ () {
272         test_fixed=$(($test_fixed+1))
273         say_color "" "ok $test_count - $@ # TODO known breakage"
274 }
275
276 test_known_broken_failure_ () {
277         test_broken=$(($test_broken+1))
278         say_color skip "not ok $test_count - $@ # TODO known breakage"
279 }
280
281 test_debug () {
282         test "$debug" = "" || eval "$1"
283 }
284
285 test_eval_ () {
286         # This is a separate function because some tests use
287         # "return" to end a test_expect_success block early.
288         eval </dev/null >&3 2>&4 "$*"
289 }
290
291 test_run_ () {
292         test_cleanup=:
293         expecting_failure=$2
294         test_eval_ "$1"
295         eval_ret=$?
296
297         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
298         then
299                 test_eval_ "$test_cleanup"
300         fi
301         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
302                 echo ""
303         fi
304         return "$eval_ret"
305 }
306
307 test_skip () {
308         test_count=$(($test_count+1))
309         to_skip=
310         for skp in $GIT_SKIP_TESTS
311         do
312                 case $this_test.$test_count in
313                 $skp)
314                         to_skip=t
315                         break
316                 esac
317         done
318         if test -z "$to_skip" && test -n "$test_prereq" &&
319            ! test_have_prereq "$test_prereq"
320         then
321                 to_skip=t
322         fi
323         case "$to_skip" in
324         t)
325                 of_prereq=
326                 if test "$missing_prereq" != "$test_prereq"
327                 then
328                         of_prereq=" of $test_prereq"
329                 fi
330
331                 say_color skip >&3 "skipping test: $@"
332                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
333                 : true
334                 ;;
335         *)
336                 false
337                 ;;
338         esac
339 }
340
341 # stub; perf-lib overrides it
342 test_at_end_hook_ () {
343         :
344 }
345
346 test_done () {
347         GIT_EXIT_OK=t
348
349         if test -z "$HARNESS_ACTIVE"; then
350                 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
351                 mkdir -p "$test_results_dir"
352                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
353
354                 cat >>"$test_results_path" <<-EOF
355                 total $test_count
356                 success $test_success
357                 fixed $test_fixed
358                 broken $test_broken
359                 failed $test_failure
360
361                 EOF
362         fi
363
364         if test "$test_fixed" != 0
365         then
366                 say_color pass "# fixed $test_fixed known breakage(s)"
367         fi
368         if test "$test_broken" != 0
369         then
370                 say_color error "# still have $test_broken known breakage(s)"
371                 msg="remaining $(($test_count-$test_broken)) test(s)"
372         else
373                 msg="$test_count test(s)"
374         fi
375         case "$test_failure" in
376         0)
377                 # Maybe print SKIP message
378                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
379
380                 if test $test_external_has_tap -eq 0; then
381                         say_color pass "# passed all $msg"
382                         say "1..$test_count$skip_all"
383                 fi
384
385                 test -d "$remove_trash" &&
386                 cd "$(dirname "$remove_trash")" &&
387                 rm -rf "$(basename "$remove_trash")"
388
389                 test_at_end_hook_
390
391                 exit 0 ;;
392
393         *)
394                 if test $test_external_has_tap -eq 0; then
395                         say_color error "# failed $test_failure among $msg"
396                         say "1..$test_count"
397                 fi
398
399                 exit 1 ;;
400
401         esac
402 }
403
404 if test -n "$valgrind"
405 then
406         make_symlink () {
407                 test -h "$2" &&
408                 test "$1" = "$(readlink "$2")" || {
409                         # be super paranoid
410                         if mkdir "$2".lock
411                         then
412                                 rm -f "$2" &&
413                                 ln -s "$1" "$2" &&
414                                 rm -r "$2".lock
415                         else
416                                 while test -d "$2".lock
417                                 do
418                                         say "Waiting for lock on $2."
419                                         sleep 1
420                                 done
421                         fi
422                 }
423         }
424
425         make_valgrind_symlink () {
426                 # handle only executables, unless they are shell libraries that
427                 # need to be in the exec-path.  We will just use "#!" as a
428                 # guess for a shell-script, since we have no idea what the user
429                 # may have configured as the shell path.
430                 test -x "$1" ||
431                 test "#!" = "$(head -c 2 <"$1")" ||
432                 return;
433
434                 base=$(basename "$1")
435                 symlink_target=$GIT_BUILD_DIR/$base
436                 # do not override scripts
437                 if test -x "$symlink_target" &&
438                     test ! -d "$symlink_target" &&
439                     test "#!" != "$(head -c 2 < "$symlink_target")"
440                 then
441                         symlink_target=../valgrind.sh
442                 fi
443                 case "$base" in
444                 *.sh|*.perl)
445                         symlink_target=../unprocessed-script
446                 esac
447                 # create the link, or replace it if it is out of date
448                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
449         }
450
451         # override all git executables in TEST_DIRECTORY/..
452         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
453         mkdir -p "$GIT_VALGRIND"/bin
454         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
455         do
456                 make_valgrind_symlink $file
457         done
458         # special-case the mergetools loadables
459         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
460         OLDIFS=$IFS
461         IFS=:
462         for path in $PATH
463         do
464                 ls "$path"/git-* 2> /dev/null |
465                 while read file
466                 do
467                         make_valgrind_symlink "$file"
468                 done
469         done
470         IFS=$OLDIFS
471         PATH=$GIT_VALGRIND/bin:$PATH
472         GIT_EXEC_PATH=$GIT_VALGRIND/bin
473         export GIT_VALGRIND
474 elif test -n "$GIT_TEST_INSTALLED" ; then
475         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
476         error "Cannot run git from $GIT_TEST_INSTALLED."
477         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
478         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
479 else # normal case, use ../bin-wrappers only unless $with_dashes:
480         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
481         if ! test -x "$git_bin_dir/git" ; then
482                 if test -z "$with_dashes" ; then
483                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
484                 fi
485                 with_dashes=t
486         fi
487         PATH="$git_bin_dir:$PATH"
488         GIT_EXEC_PATH=$GIT_BUILD_DIR
489         if test -n "$with_dashes" ; then
490                 PATH="$GIT_BUILD_DIR:$PATH"
491         fi
492 fi
493 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
494 unset GIT_CONFIG
495 GIT_CONFIG_NOSYSTEM=1
496 GIT_ATTR_NOSYSTEM=1
497 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
498
499 if test -z "$GIT_TEST_CMP"
500 then
501         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
502         then
503                 GIT_TEST_CMP="$DIFF -c"
504         else
505                 GIT_TEST_CMP="$DIFF -u"
506         fi
507 fi
508
509 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
510 export GITPERLLIB
511 test -d "$GIT_BUILD_DIR"/templates/blt || {
512         error "You haven't built things yet, have you?"
513 }
514
515 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
516 then
517         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
518         export GITPYTHONLIB
519         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
520                 error "You haven't built git_remote_helpers yet, have you?"
521         }
522 fi
523
524 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
525         echo >&2 'You need to build test-chmtime:'
526         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
527         exit 1
528 fi
529
530 # Test repository
531 test="trash directory.$(basename "$0" .sh)"
532 test -n "$root" && test="$root/$test"
533 case "$test" in
534 /*) TRASH_DIRECTORY="$test" ;;
535  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
536 esac
537 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
538 rm -fr "$test" || {
539         GIT_EXIT_OK=t
540         echo >&5 "FATAL: Cannot prepare test area"
541         exit 1
542 }
543
544 HOME="$TRASH_DIRECTORY"
545 export HOME
546
547 if test -z "$TEST_NO_CREATE_REPO"; then
548         test_create_repo "$test"
549 else
550         mkdir -p "$test"
551 fi
552 # Use -P to resolve symlinks in our working directory so that the cwd
553 # in subprocesses like git equals our $PWD (for pathname comparisons).
554 cd -P "$test" || exit 1
555
556 this_test=${0##*/}
557 this_test=${this_test%%-*}
558 for skp in $GIT_SKIP_TESTS
559 do
560         case "$this_test" in
561         $skp)
562                 say_color skip >&3 "skipping test $this_test altogether"
563                 skip_all="skip all tests in $this_test"
564                 test_done
565         esac
566 done
567
568 # Provide an implementation of the 'yes' utility
569 yes () {
570         if test $# = 0
571         then
572                 y=y
573         else
574                 y="$*"
575         fi
576
577         while echo "$y"
578         do
579                 :
580         done
581 }
582
583 # Fix some commands on Windows
584 case $(uname -s) in
585 *MINGW*)
586         # Windows has its own (incompatible) sort and find
587         sort () {
588                 /usr/bin/sort "$@"
589         }
590         find () {
591                 /usr/bin/find "$@"
592         }
593         sum () {
594                 md5sum "$@"
595         }
596         # git sees Windows-style pwd
597         pwd () {
598                 builtin pwd -W
599         }
600         # no POSIX permissions
601         # backslashes in pathspec are converted to '/'
602         # exec does not inherit the PID
603         test_set_prereq MINGW
604         test_set_prereq SED_STRIPS_CR
605         ;;
606 *CYGWIN*)
607         test_set_prereq POSIXPERM
608         test_set_prereq EXECKEEPSPID
609         test_set_prereq NOT_MINGW
610         test_set_prereq SED_STRIPS_CR
611         ;;
612 *)
613         test_set_prereq POSIXPERM
614         test_set_prereq BSLASHPSPEC
615         test_set_prereq EXECKEEPSPID
616         test_set_prereq NOT_MINGW
617         ;;
618 esac
619
620 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
621 test -z "$NO_PERL" && test_set_prereq PERL
622 test -z "$NO_PYTHON" && test_set_prereq PYTHON
623 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
624 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
625
626 # Can we rely on git's output in the C locale?
627 if test -n "$GETTEXT_POISON"
628 then
629         GIT_GETTEXT_POISON=YesPlease
630         export GIT_GETTEXT_POISON
631         test_set_prereq GETTEXT_POISON
632 else
633         test_set_prereq C_LOCALE_OUTPUT
634 fi
635
636 # Use this instead of test_cmp to compare files that contain expected and
637 # actual output from git commands that can be translated.  When running
638 # under GETTEXT_POISON this pretends that the command produced expected
639 # results.
640 test_i18ncmp () {
641         test -n "$GETTEXT_POISON" || test_cmp "$@"
642 }
643
644 # Use this instead of "grep expected-string actual" to see if the
645 # output from a git command that can be translated either contains an
646 # expected string, or does not contain an unwanted one.  When running
647 # under GETTEXT_POISON this pretends that the command produced expected
648 # results.
649 test_i18ngrep () {
650         if test -n "$GETTEXT_POISON"
651         then
652             : # pretend success
653         elif test "x!" = "x$1"
654         then
655                 shift
656                 ! grep "$@"
657         else
658                 grep "$@"
659         fi
660 }
661
662 test_lazy_prereq SYMLINKS '
663         # test whether the filesystem supports symbolic links
664         ln -s x y && test -h y
665 '
666
667 test_lazy_prereq CASE_INSENSITIVE_FS '
668         echo good >CamelCase &&
669         echo bad >camelcase &&
670         test "$(cat CamelCase)" != good
671 '
672
673 test_lazy_prereq UTF8_NFD_TO_NFC '
674         # check whether FS converts nfd unicode to nfc
675         auml=$(printf "\303\244")
676         aumlcdiar=$(printf "\141\314\210")
677         >"$auml" &&
678         case "$(echo *)" in
679         "$aumlcdiar")
680                 true ;;
681         *)
682                 false ;;
683         esac
684 '
685
686 # When the tests are run as root, permission tests will report that
687 # things are writable when they shouldn't be.
688 test -w / || test_set_prereq SANITY